/***********************************************************************************
                         anselm.ru [2014-04-24] GNU GPL
***********************************************************************************/
#include "string.h"
#include <math.h>    //pow

//http://linux.about.com/library/cmd/blcmdl1_perlembed.htm
#ifdef PERLEMBED
#include <EXTERN.h>  // from the Perl distribution 
#include <perl.h>    // from the Perl distribution
map<pthread_t, PerlInterpreter* > context;//pthread_self()
PerlInterpreter*
get_perl_context() { // в каждом потоке будет создан свой перл-контекст
  map<pthread_t, PerlInterpreter* >::iterator I = context.find(pthread_self());
  if(I != context.end())
    return I->second;
  else { // создаём новый контекст интерпретатора
    //PERL_SYS_INIT3(0,NULL,NULL);//PERL_SYS_INIT3(&argc,&argv,&env);
    PerlInterpreter *my_perl = perl_alloc();
    //printf("*%p->%p\n", pthread_self(), my_perl);
    context.insert( pair<pthread_t, PerlInterpreter* >(pthread_self(), my_perl) );
    perl_construct( my_perl );
    const char *embedding[] = { "", "-e", "0" };
    perl_parse(my_perl, NULL, 3, (char**)embedding, NULL);
    PL_exit_flags |= PERL_EXIT_DESTRUCT_END;
    perl_run(my_perl);
    return my_perl;
  }
}
#endif



/*void
String::init_perl() const { // в каждом потоке будет создан свой перл-контекст
#ifdef PERLEMBED
  map<pthread_t, PerlInterpreter* >::iterator I = context.find(pthread_self());
  if(I == context.end()) { // создаём новый контекст интерпретатора
    //PERL_SYS_INIT3(0,NULL,NULL);//PERL_SYS_INIT3(&argc,&argv,&env);
    PerlInterpreter *my_perl = perl_alloc();
    //printf("*%p->%p\n", pthread_self(), my_perl);
    context.insert( pair<pthread_t, PerlInterpreter* >(pthread_self(), my_perl) );
    perl_construct( my_perl );
    const char *embedding[] = { "", "-e", "0" };
    perl_parse(my_perl, NULL, 3, (char**)embedding, NULL);
    PL_exit_flags |= PERL_EXIT_DESTRUCT_END;
    perl_run(my_perl);
  }
#endif
}

void
String::free_perl() const { // удалять контекст не рекомендуется - им могут воспользоваться другие переменные
#ifdef PERLEMBED
  map<pthread_t, PerlInterpreter* >::iterator I = context.find(pthread_self());
  if(I != context.end()) { // создаём новый контекст интерпретатора
    PerlInterpreter *my_perl = I->second;
    //printf("~%p->%p\n", pthread_self(), my_perl);
    context.erase(I);
    perl_destruct(my_perl);
    perl_free(my_perl);
    //PERL_SYS_TERM();
  }
#endif  
}*/

String
String::trim() const {
  String s = *this;
  const char* t = (char*)" \t\n\r\f";
  s.erase(0, s.find_first_not_of(t));
  s.erase(s.find_last_not_of(t)+1);
  return s;
}

String
String::eval() const {
  String s;
#ifdef PERLEMBED
  s = String::sprintf("$return = do{ %s }", c_str());
  PerlInterpreter *my_perl = get_perl_context();
  PERL_SET_CONTEXT(my_perl);
  ENTER;
  SAVETMPS;
  //CLEAR_ERRSV();
  eval_pv(s.c_str(), FALSE); //FALSE - не вырубать программу при ошибках в перл-выражениях
  if(SvTRUE(ERRSV)) {
    s = sprintf("ERROR: %s", SvPVx_nolen(ERRSV));
    CLEAR_ERRSV();
  }
  else {
    SV* val = get_sv("return", 0);//perl_get_sv("return", FALSE)
    s = SvPV_nolen(val);
  }
  FREETMPS;
  LEAVE;
#endif

#ifdef PERLSTD
  s = perl( String::sprintf("print do{ %s }", c_str()) );
#endif  
  
  return s;
}

String&
String::replace(const String& pattern) {
#ifdef PERLEMBED
  String s = String::sprintf("$string = '%s'; ($string =~ %s)", c_str(), pattern.c_str());
  PerlInterpreter *my_perl = get_perl_context();
  PERL_SET_CONTEXT(my_perl);
  ENTER;
  SAVETMPS;
  eval_pv(s.c_str(), FALSE);
  SV* val = get_sv("string", 0);//perl_get_sv("return", FALSE)
  *this = SvPV_nolen(val);
  FREETMPS;
  LEAVE;
#endif

#ifdef PERLSTD
  String s = String::sprintf("$s=\"%s\"; $s=~%s; print $s", c_str(), pattern.c_str());
  *this = perl(s);
#endif
    
  return *this;
}

bool
String::match(const String& pattern) const {
  int ret = 0;
#ifdef PERLEMBED
  String s = String::sprintf("$string = '%s'; $string =~ %s", c_str(), pattern.c_str());
  PerlInterpreter *my_perl = get_perl_context();
  PERL_SET_CONTEXT(my_perl);
  ENTER;
  SAVETMPS;
  eval_pv(s.c_str(), FALSE);
  SV* val = get_sv("string", 0);//perl_get_sv("return", FALSE)
  ret = SvIV(val);
  FREETMPS;
  LEAVE;
#endif

#ifdef PERLSTD
  String s = String::sprintf("print \"%s\"=~%s", c_str(), pattern.c_str());
  ret = perl(s).toBoolean();
#endif
  
  return ret;
}

int
String::matches(const String& pattern, list<String> &a) const {
  int num_matches = 0;
#ifdef PERLEMBED
  String s = String::sprintf("$string = '%s'; @array = ($string =~ %s)", c_str(), pattern.c_str());
  PerlInterpreter *my_perl = get_perl_context();
  PERL_SET_CONTEXT(my_perl);
  ENTER;
  SAVETMPS;
  eval_pv(s.c_str(), FALSE);
  AV *match_list = get_av("array", 0);//perl_get_sv("return", FALSE)
  num_matches = AvFILL(match_list)+1; //I32 num_matches = AvFILL(match_list)+1;
  for(I32 i = 0; i < num_matches; i++) {
    a.push_front(SvPV_nolen(*av_fetch(match_list, i, FALSE)));
  }
  FREETMPS;
  LEAVE;
#endif

#ifdef PERLSTD
  String s = String::sprintf("$s=\"%s\"; @a=($s=~%s); print join(\"\n\", @a)", c_str(), pattern.c_str()); // разделителем строк будет "\n"
  s = perl(s);
  
  istringstream ss(s);
  while(getline(ss, s)) a.push_back(s);
  
  num_matches = a.size();
#endif

    
  return num_matches;
}

int
String::matches(const String& pattern, list<int> &a) const {
  int num_matches = 0;
#ifdef PERLEMBED
  String s = String::sprintf("$string = '%s'; @array = ($string =~ %s)", c_str(), pattern.c_str());
  PerlInterpreter *my_perl = get_perl_context();
  PERL_SET_CONTEXT(my_perl);
  ENTER;
  SAVETMPS;
  eval_pv(s.c_str(), FALSE);
  AV *match_list = get_av("array", 0);//perl_get_sv("return", FALSE)
  num_matches = AvFILL(match_list)+1; //I32 num_matches = AvFILL(match_list)+1;
  for(I32 i = 0; i < num_matches; i++) {
    a.push_front(SvIV(*av_fetch(match_list, i, FALSE)));
  }
  FREETMPS;
  LEAVE;
#endif

#ifdef PERLSTD
  String s = String::sprintf("$s=\"%s\"; @a=($s=~%s); print join(\" \", @a)", c_str(), pattern.c_str()); // разделителем чисел достаточно сделать пробел
  s = perl(s);
  stringstream ss(s);
  istream_iterator<int> b(ss), e;
  std::copy(b, e, inserter(a, a.begin()));
  //std::copy(a.begin(), a.end(), ostream_iterator<int> (cout, ":"));
  
  num_matches = a.size();
#endif
  
  return num_matches;
}

String
String::bprintf(const String& format) const {
  String s = *this;
  if(s.empty()) { // если пусто, то пустоту и возвращаем
    return s;
  }
  const int n = format.size()+s.size()*2+1; //TODO 1 байт, 2 байта или 4 байта на символ? 1 байт - мало!
  char *buf = new char[n];
  bnprintf(s.data(), s.size(), format.c_str(), buf, n);
  s = buf;
  delete [] buf;
  return s;
}

String
String::sprintf(const String& format, ...) {
  va_list paramList;
  va_start(paramList, format);
  int len = format.size()+1, add = len, i;
  char *str = (char*)malloc(len+=add);
  while ( (i = (vsnprintf(str, len, format.c_str(), paramList))) == -1 || len<=i ) { //becose exists different agreaments about return
    str = (char*)realloc(str, len+=add);
  }
  va_end(paramList);
  String s = str;
  free(str);
  
  return s;
}


#define BLOCK_SPRINTF \
  if(b+sizeof(Type)>b0+size_data) \
    result = -1; \
  else { \
    result = ::sprintf(ret, left, *(Type*)b ); \
    b += sizeof(Type); \
  }

int
String::bnprintf(const void *data, const size_t size_data, const char *format, char *ret, const size_t size_ret) {
  char *left  = (char*) malloc(size_ret);
  char *right = (char*) malloc(size_ret);  
  strcpy(ret, format);  
  const char *b = (const char*) data, *b0=b;

  char *pos;
  while( (pos=strchr(ret, '%')) ) {
    int i = pos-ret;
    if(i>=size_ret-1) {         // если '%' стоит в самом конце строки и даже дальше
      memset(ret, 0, size_ret); //strcpy(ret, "error");
      break;
    }
    char *pos2 = strpbrk(&ret[i+1], "eEfFgGaAdiouxXs");
    if(pos2==NULL) {            // это может случиться в случае неправильного формата
      memset(ret, 0, size_ret); //strcpy(ret, "error");//
      break;
    }
    int j = pos2-ret;

    memset(left,  0, size_ret);
    memset(right, 0, size_ret);
    strncpy(left, ret, j+1);
    strcpy(right, &ret[j+1]);

    int result;
    
    if( strchr("eEfFgGaA",ret[j]) ) {
      if(ret[j-1]=='l') {
        typedef double Type;
        BLOCK_SPRINTF;
      }
      else {
        typedef float Type;
        BLOCK_SPRINTF;
      }
    }
    else if( strchr("di",ret[j]) ) {
      if(ret[j-1]=='l') {
        typedef long Type;
        BLOCK_SPRINTF;
      }
      else {
        typedef int Type;        
        BLOCK_SPRINTF;
        //warning("Type=int, ret=%s, left=%s", ret, left);
      }      
    }
    else if( strchr("ouxX",ret[j]) ) {
      if(ret[j-1]=='l') {
        typedef unsigned long Type;
        BLOCK_SPRINTF;
      }
      else {
        typedef unsigned int Type;
        BLOCK_SPRINTF;
      }      
    }
    else if( strchr("s",ret[j]) ) {
      if(ret[j-1]=='l') {
        int len = wcstombs(ret, (wchar_t*) b, strlen(b)) * sizeof(wchar_t);//TODO есть сомнения
        if(b+len>b0+size_data) {
          result = -1;
        }
        else {
          left[j-1] = 's'; left[j] = 0;
          char *tmp = ::strdup(ret);
          result = ::sprintf(ret, left, tmp);
          b += len+sizeof(wchar_t);
          free(tmp);
        }
      }
      else {
        if(b+strlen(b)>b0+size_data)
          result = -1;
        else {
          result = ::sprintf(ret, left, b);
          b += strlen(b)+1;
        }
      }
    }
    else {
      result = -1; // всё остальное форматирование пока запретим
    }
    
    if(result==-1) {
      memset(ret, 0, size_ret);//strcpy(ret, "error");//
      break;
    }
    
    strcat(ret, right);
  }
  
  
  free(left);
  free(right);
  
  return strlen(ret);
}

String
String::perl(const String& expr) {
  //execl("/bin/sh", "sh", "-c", cmdstring, (char *)0);
  //execl("/usr/bin/perl", "perl", "-e", expr, buf);
  const char * PERL = "perl -e '%s'";
  const int OUT_LEN = 50; //размер роли не играет
    
  char out[OUT_LEN], *in = new char[strlen(PERL)+expr.size()+1];
  ::sprintf(in, PERL, expr.c_str());
  
  String s;
  
  FILE *fpin;
  if((fpin = popen(in, "r")) == NULL) {
    fprintf(stderr, "error рореn %s\n", in);
    delete [] in;
    return s;
  }
  
  delete [] in;
  
  while( fgets(out, OUT_LEN, fpin) ) { //eof
    s+=out;
    //fprintf(stderr,"error fgets\n"); /* чтение из канала */
    //if(pclose(fpin) == -1) fprintf(stderr,"error pclose\n"); // тут наверно надо просто гасить программу, т.к. есть опасность открытия многих экземпляров perl
    //return s;
  }
  
  if(pclose(fpin) == -1) {
    fprintf(stderr,"error pclose\n");
    return s;
  }
  
  return s;
}

unsigned wchar_t
makeword(char a, char b) {
  return (unsigned wchar_t)((a&0xff)<<8)+(unsigned wchar_t)(b&0xff);
}

const wchar_t*
String::utf16(const char* defaults) {
  const char* a = empty() ? defaults : c_str();      
  const size_t n = strlen(a);   
  if(d_wchar) delete [] d_wchar;
  d_wchar = new wchar_t[n+1];
  memset(d_wchar, 0, (n+1) * sizeof(wchar_t));
  
  int j = 0;
  for(int i=0; i<n; i++) {
    if(a[i] & 0x80) { // если старший бит не ноль
      d_wchar[j]   = makeword(a[i], a[i+1]);
      if(a[i] & 0x01) // если младший бит ноль
        d_wchar[j] -= 0xCD40;
      else
        d_wchar[j] -= 0xCC80;
      i++;
    }
    else {
      d_wchar[j]   = makeword(0x00, a[i]);
    }
    j++;
  }
  return d_wchar;
}

/*******************************************************************************
Распознание будет осуществляться по такому правилу:
если имеется указание на временную зону, значит речь идёт об времени UTC;
если временная зона не указана, значит предполагается время местное.
******************************************************************************/
timeval String::to_timeval() const { 
	timeval tv = {0};
	
  //char *a = strdup(string::c_str());
  const char *a = strdup(string::c_str());
  // распознаем микросекунды
  char *s;
  if( (s=strchr(a, '.')) && s++ ) {
    int len = strspn(s, "0123456789");
    tv.tv_usec = strtol(s, NULL, 10) * pow(10, 6-len);
  }
  else {
    tv.tv_usec = 0;
  }

  // распознаем временнУю зону и удалим её из строки, т.к. она может смутить следующую ф-ю sscanf
  int z=0;
  bool tz_def = false;
  if( strlen(a)>10 && (s=strpbrk(a+10, "-+"))) {
    z = strtol(s, NULL, 10);
    *s = 0; // отсекаем временную зону
    tz_def = true;
  }
  
  // распознаем дату и время в формате ISO 8601
  int y=0,m=0,d=0,H=0,M=0,S=0;
  sscanf(a, "%u-%u-%u %u:%u:%u", &y, &m, &d, &H, &M, &S);
  delete [] a;
  
  //printf("%u-%u-%u %u:%u:%u.%u %d\n", y, m, d, H, M, S, tv_usec, z);
  
  tm t = {0};
  t.tm_year  = y-1900;
  t.tm_mon   = m-1;
  t.tm_mday  = d;
  t.tm_hour  = H;
  t.tm_min   = M;
  t.tm_sec   = S;
  t.tm_isdst = -1;//очень важно!
  //t.tm_gmtoff = z*3600;
  
  if(tz_def) // если временная зона указана, то UTC
    if(z<100) //TODO если временная зона в формате +-0600
      tv.tv_sec = timegm(&t)-z*3600; 
    else
      tv.tv_sec = timegm(&t)-z*36;
  else     // если временная зона НЕ указана, то местное
    tv.tv_sec = mktime(&t);
    
  return tv;
}
